/********************************** (C) COPYRIGHT *********************************
* File Name          : CH456IF.H
* Author             : tech
* Version            : V1.0
* Date               : 2013/07/06
* Description        : CH456Ӳӿڳ
**********************************************************************************/
/*********************************************************************************
  CH4562߽ӿڣֻҪ2I/OţI2C/IICʱ
 Ϊ˽Լʱ䣬ʵSCL/SDA֮ʱ
 ϣSCL·ãôֻҪSDA仯SCLͿκ;
 ϣSCLSDA·ãôؼȷSDAֻSCLΪ͵ƽڼ䷢仯SCLSDAʺΪʹ
     1SCLţֱ
     2SDAţʱ
          SCLΪ͵ƽôֱ
          SCLΪߵƽôȽSCL͵ƽٽSDASCLָΪߵƽ
*********************************************************************************/
#include "CH456IF.H"

void CH456_I2c_Start( void )  // ʼ
{
	CH456_SDA_SET;   /*ʼź*/
	CH456_SDA_D_OUT;   /* SDAΪ */
	CH456_SCL_SET;
	CH456_SCL_D_OUT;   /* SCLΪ */
	DELAY;
	CH456_SDA_CLR;   /*ʼź*/
	DELAY;      
	CH456_SCL_CLR;   /*ǯסI2Cߣ׼ͻ */
}

void CH456_I2c_Stop( void )  // 
{
	CH456_SDA_CLR;
	CH456_SDA_D_OUT;   /* SDAΪ */
	DELAY;
	CH456_SCL_SET;
	DELAY;
	CH456_SDA_SET;  /*I2C߽ź*/
	DELAY;
	CH456_SDA_D_IN;   /* SDAΪ뷽 */
}

void CH456_I2c_WrByte( UINT8 dat )	//дһֽ
{
	UINT8 i;
	CH456_SDA_D_OUT;   /* SDAΪ */
	for( i = 0; i != 8; i++ )  // 8λ
	{
		if( dat & 0x80 ) 
		{
		    CH456_SDA_SET;
		}
		else 
		{
		    CH456_SDA_CLR;
		}
		DELAY;
		CH456_SCL_SET;
		DELAY;  // ѡʱ
		CH456_SCL_CLR;
		dat <<= 1;
	}
	CH456_SDA_D_IN;   /* SDAΪ뷽 */
	CH456_SDA_SET;
	DELAY;
	CH456_SCL_SET;  // Ӧ
	DELAY;
	CH456_SCL_CLR;
}

UINT8  CH456_I2c_RdByte( void )		//һֽ
{
	UINT8 dat,i;
	CH456_SDA_D_IN;   /* SDAΪ뷽 */
//	CH456_SDA_SET;
	dat = 0;
	for( i = 0; i != 8; i++ )  // 8λ
	{
		DELAY;  // ѡʱ
		CH456_SCL_SET;
		DELAY;  // ѡʱ
		dat <<= 1;
		if( CH456_SDA_IN ) dat++;  // 1λ
		CH456_SCL_CLR;
	}
	CH456_SDA_SET;
	CH456_SDA_D_OUT;
	DELAY;
	CH456_SCL_SET;  // ЧӦ
	DELAY;
	CH456_SCL_CLR;
	return dat;
}

void CH456_Write( UINT16 cmd )	//д
{
	CH456_I2c_Start();               //
   	CH456_I2c_WrByte( ( UINT8 )( cmd>>8 ) );
   	CH456_I2c_WrByte((UINT8)cmd);               //
  	CH456_I2c_Stop();                 // 
}

UINT8 CH456_Read( void )		//ȡ
{
	UINT8 keycode;
   	CH456_I2c_Start();                //
   	CH456_I2c_WrByte((UINT8)(CH456_GET_KEY>>8));
   	keycode=CH456_I2c_RdByte();      //ȡ
	CH456_I2c_Stop();                //
	return keycode;
}
